/*==============================================================================
// 
//	File: ExportTemplatePIE.h
//
//
//	Argus Numerical Environments - Plug In Extension, Release 1.0
// 
//	Copyright  1996 Argus Holdings Ltd.  All rights reserved.
//
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Argus Holdings Ltd..
// The copyright notice above does not evidence any
// actual or intended publication of such source code
//==============================================================================*/

#ifndef _ExportTemplatePIE_H_
#define _ExportTemplatePIE_H_

#ifndef _ANEPIE_H_
#include "ANEPIE.h"
#endif /* _ANEPIE_H_ */

#define EXPORT_TEMPLATE_PIE_VERSION 1

#ifdef __cplusplus
extern "C" {
#endif
typedef void (*PIEExportGetTemplate)(ANE_PTR aneHandle, ANE_STR* returnTemplate);
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef void (*PIEExportCallBack)(ANE_PTR aneHandle);
#ifdef __cplusplus
}
#endif


enum EExportTemplateFlags {kExportDontShowParamDialog = 0x1,
			kExportDontShowFileDialog = 0x2,
			kExportCallPreExport = 0x4,
			kExportCallPostExport = 0x8,
			kExportDontGetTemplate = 0x10,
			kExportNeedsProject		= 0x20};

struct ExportTemplatePIEDesc
{
		ANE_INT32		version;
		ANE_STR			name;
		enum EPIELayerType			exportType;
		enum EExportTemplateFlags	exportFlags;
		PIEExportGetTemplate		getTemplateProc;
		PIEExportCallBack		preExportProc;
		PIEExportCallBack		postExportProc;
		ANE_STR						neededProject;
}; /* FunctionPIEDesc */




#endif /* _ExportTemplatePIE_H_ */

/*==============================================================================
//	End File: ExportTemplatePIE.h
//==============================================================================*/
