// Pane1.cpp : implementation file
//

#include "stdafx.h"
#include "sutra.h"
#include "Pane1.h"
#include "TabbedDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPane1 property page

static UINT disableForUserSpec[] = { IDC_SIMULA};

IMPLEMENT_DYNCREATE(CPane1, CBasePropertyPage)

CPane1::CPane1() : CBasePropertyPage(CPane1::IDD)
{
	//{{AFX_DATA_INIT(CPane1)
	m_NTOBS = 0;
	m_SIMULA = _T("");
	m_TITLE1 = _T("");
	m_TITLE2 = _T("");
	//}}AFX_DATA_INIT
}

CPane1::~CPane1()
{
}

void CPane1::DoDataExchange(CDataExchange* pDX)
{
	CBasePropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPane1)
	DDX_CBString(pDX, IDC_SIMULA, m_SIMULA);
	DDX_Text(pDX, IDC_TITLE, m_TITLE1);
	DDV_MaxChars(pDX, m_TITLE1, 80);
	DDX_Text(pDX, IDC_TITLE2, m_TITLE2);
	DDV_MaxChars(pDX, m_TITLE2, 80);
	//}}AFX_DATA_MAP

	CTabbedDialog* tabbedDialog = (CTabbedDialog*)this->GetParent();
	tabbedDialog->m_EnergySimulation = (m_SIMULA == "SUTRA ENERGY TRANSPORT");
}


BEGIN_MESSAGE_MAP(CPane1, CBasePropertyPage)
	//{{AFX_MSG_MAP(CPane1)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPane1 message handlers

void CPane1::ReturnValues(SUTRAProjectInfo &info)
{
	info.NTOBS = m_NTOBS;
	info.SIMULA = m_SIMULA;
	info.TITLE1 = m_TITLE1;
	info.TITLE2 = m_TITLE2;
}

void CPane1::GetValues(SUTRAProjectInfo &info)
{
	m_NTOBS = info.NTOBS;
	m_SIMULA = info.SIMULA;
	m_TITLE1 = info.TITLE1;
	m_TITLE2 = info.TITLE2;

	m_userSpecMode = !info.defaultSetting;
	m_orientation = info.orientation;
	m_flowConditions = info.flowConditions;
	m_transportConditions = info.transportConditions;
	m_modelThickness = info.modelThickness;
	m_meshDesign = info.meshDesign;
}

BOOL CPane1::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	this->EnableControls(disableForUserSpec, SIZEOF_ARRAY(disableForUserSpec), !m_userSpecMode);

	if (!m_userSpecMode)
	{
		GetDlgItem(IDC_PS1)->SetWindowText("Project type: General");
	}
	else
	{
		GetDlgItem(IDC_PS1)->SetWindowText("Project type: User Specified");
		
		if (m_orientation==SUTRAProjectInfo::kAREAL)
			GetDlgItem(IDC_PS2)->SetWindowText("Orientation: AREAL");
		else
			GetDlgItem(IDC_PS2)->SetWindowText("Orientation: CROSS-SECTIONAL or DIPPED");

		if (m_flowConditions==SUTRAProjectInfo::kSATURATED)
			GetDlgItem(IDC_PS3)->SetWindowText("Flow conditions: SATURATED");
		else
			GetDlgItem(IDC_PS3)->SetWindowText("Flow conditions: SATURATED-UNSATURATED");

		if (m_transportConditions==SUTRAProjectInfo::kSOLUTE_VAR)
			GetDlgItem(IDC_PS4)->SetWindowText("Transport conditions: SOLUTE (Variable-density fluid, using Pressure)");
		else if (m_transportConditions==SUTRAProjectInfo::kSOLUTE_CONST)
			GetDlgItem(IDC_PS4)->SetWindowText("Transport conditions: SOLUTE (Constant-Density fluid, using Hydraulic Head)");
		else
			GetDlgItem(IDC_PS4)->SetWindowText("Transport conditions: ENERGY (Variable-density fluid, using Pressure)");

		if (m_modelThickness==SUTRAProjectInfo::kUSER_SPEC)
			GetDlgItem(IDC_PS5)->SetWindowText("Model thickness: USER SPECIFIED (constant or variable thickness)");
		else
			GetDlgItem(IDC_PS5)->SetWindowText("Model thickness: CYLINDRICAL (simulation of radial flow)");

		if (m_meshDesign==SUTRAProjectInfo::kFISHNET_MESH)
			GetDlgItem(IDC_PS6)->SetWindowText("Mesh design: FISHNET (a deformable grid of quadrilaterals)");
		else
			GetDlgItem(IDC_PS6)->SetWindowText("Mesh design: IRREGULAR (ArgusONE chooses element shapes and locations)");

	}

	return CBasePropertyPage::OnSetActive();
}
