// SelectPostProcDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Sutra.h"
#include "SelectPostProcDialog.h"
#include "SutraPostProc_PIE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectPostProcDialog dialog


CSelectPostProcDialog::CSelectPostProcDialog(PeriodsInfo* periodsInfo, CWnd* pParent /*=NULL*/)
	: CDialog(CSelectPostProcDialog::IDD, pParent), m_periodsInfo(periodsInfo)
{
	//{{AFX_DATA_INIT(CSelectPostProcDialog)
	m_overlayCharts = TRUE;
	//}}AFX_DATA_INIT
}


void CSelectPostProcDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectPostProcDialog)
	DDX_Control(pDX, IDC_STEPSLIST, m_StepsList);
	DDX_Check(pDX, IDC_OVERLAY, m_overlayCharts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectPostProcDialog, CDialog)
	//{{AFX_MSG_MAP(CSelectPostProcDialog)
	ON_NOTIFY(NM_CLICK, IDC_STEPSLIST, OnClickStepslist)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_STEPSLIST, OnColumnclickStepslist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectPostProcDialog message handlers

BOOL CSelectPostProcDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	this->FillListBox();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectPostProcDialog::FillListBox()
{

	CListCtrl& ListCtrl= m_StepsList;

	ListCtrl.DeleteAllItems();

	int numColumns = m_periodsInfo->GetNumVariables() + 1;
	int numRows = m_periodsInfo->GetNumPeriods();

// set image lists

//m_StateImageList.Create(IDB_STATEICONS,16,1,RGB(255,0,0));


//ListCtrl.SetImageList(&m_StateImageList,LVSIL_STATE);

// insert columns

	int i, j;
	LV_COLUMN lvc;

	lvc.mask = LVCF_FMT;
	if (FALSE == ListCtrl.GetColumn(0, &lvc)) 
	{
		lvc.mask=LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		for(i=0; i<numColumns; i++)
		{
			lvc.iSubItem=i;
			if (i == 0)
				lvc.pszText= "Time Step";
			else
				lvc.pszText= (char*)(const char*)m_periodsInfo->GetVariableName(i-1);

			if (i == 0)
				lvc.cx = 60;
			else
				lvc.cx = 80;

			if (i == 0)
				lvc.fmt=LVCFMT_LEFT;
			else
				lvc.fmt=LVCFMT_CENTER;

			ListCtrl.InsertColumn(i,&lvc);
		}
	}
// insert items
	long numItems = numRows;
	char itemText[30];

	LV_ITEM lvi;

	for(i=0; i<numItems; i++)
	{
		lvi.mask=LVIF_TEXT | LVIF_STATE;
		lvi.iItem=i;
		lvi.iSubItem=0;

		sprintf(itemText, "%ld", m_periodsInfo->GetVariableTimeStep(i));  // The Time Step is set here
		lvi.pszText=itemText;
		lvi.stateMask=LVIS_STATEIMAGEMASK;

		lvi.state=0;

		ListCtrl.InsertItem(&lvi);
	}


// set item text for additional columns

	for(i=0; i<numItems; i++) 
		for(j=1; j<numColumns; j++)
		{	
			lvi.mask=LVIF_TEXT;
			lvi.iItem=i;
			lvi.iSubItem=j;

			if (m_periodsInfo->GetAvailableVariable(i, j-1))
				lvi.pszText = "no";
			else
				lvi.pszText = " ";

			ListCtrl.SetItem(&lvi);
		}	
}

void CSelectPostProcDialog::SetListItemCell(int period, int variable)
{
		// use the information in m_periodsInfo to redraw the list
	CListCtrl& ListCtrl = m_StepsList;
	BOOL state = m_periodsInfo->GetRequestedVariable(period, variable);	

	LV_ITEM lvi;

	lvi.mask= LVIF_TEXT;
	lvi.iItem=period;
	lvi.iSubItem=variable+1;

	if (state)
		lvi.pszText = "YES";
	else
		lvi.pszText = "no";

	ListCtrl.SetItem(&lvi);
}

void CSelectPostProcDialog::ToggleItemCell(int period, int variable)
{
	// toggle the information in m_periodsInfo for a cell, if applicable,
	// and also call SetListItemCell
	if (m_periodsInfo->GetAvailableVariable(period, variable))
	{
		if (m_periodsInfo->GetRequestedVariable(period, variable))
			m_periodsInfo->SetRequestedVariable(period, variable, FALSE);
		else
			m_periodsInfo->SetRequestedVariable(period, variable, TRUE);
		SetListItemCell(period, variable);
	}
}

void CSelectPostProcDialog::OnClickStepslist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Get the current mouse location and convert it to client
  // coordinates.
  DWORD pos = GetMessagePos();
  CPoint pt(LOWORD(pos), HIWORD(pos));
  m_StepsList.ScreenToClient(&pt);

  // Get indexes of the first and last visible items in listview
  // control.
  int index = m_StepsList.GetTopIndex();
  int last_visible_index = index + m_StepsList.GetCountPerPage();
  if (last_visible_index > m_StepsList.GetItemCount())
      last_visible_index = m_StepsList.GetItemCount();

  // Loop until number visible items has been reached.
  while (index <= last_visible_index)
  {
      // Get the bounding rectangle of an item. If the mouse
      // location is within the bounding rectangle of the item,
      // you know you have found the item that was being clicked.
      CRect r;
      m_StepsList.GetItemRect(index, &r, LVIR_BOUNDS);
      if (r.PtInRect(pt))
      {
//          UINT flag = LVIS_SELECTED | LVIS_FOCUSED;
//          m_StepsList.SetItemState(index, flag, flag);
					INT colIndex;

					INT colEnd = r.left;
					INT numColumns = 5; // this is a guess!!!
					for (colIndex = 0; colIndex < numColumns; colIndex++)
					{
						colEnd += m_StepsList.GetColumnWidth(colIndex);
						if (pt.x < colEnd)
							break;
					}

					this->ToggleItemCell(index, colIndex-1);
	        break;
      }

      // Get the next item in listview control.
      index++;
  }


	
	*pResult = 0;
}

void CSelectPostProcDialog::OnColumnclickStepslist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	if (pNMListView->iSubItem > 0)
	{
		// change the selection of all the time periods of the column
		BOOL newState;
		BOOL newStateIsKnown = FALSE;
		
		int variable = pNMListView->iSubItem - 1;

		for (int i = 0; i < m_periodsInfo->GetNumPeriods(); i++)
		{
			if (m_periodsInfo->GetAvailableVariable(i, variable))
			{
				if (!newStateIsKnown)
				{
					newState = !m_periodsInfo->GetRequestedVariable(i, variable);
					newStateIsKnown = TRUE;
				}
				m_periodsInfo->SetRequestedVariable(i, variable, newState);
				SetListItemCell(i, variable);
			}
		}
	}
	
	*pResult = 0;
}
