/******************************************************************************\
*
*                                 sutra_pie.H
*
\******************************************************************************/

#ifndef _SUTRA_PIE_HH_
#define _SUTRA_PIE_HH_

#ifndef _FunctionPIE_H_
#include "FunctionPIE.h"
#endif /* _FunctionPIE_H_ */

#ifndef _ExportTemplatePIE_H_
#include "ExportTemplatePIE.h"
#endif /* _ExportTemplatePIE_H_ */

#ifndef _ProjectPIE_H_
#include "ProjectPIE.h"
#endif /* _ProjectPIE_H_ */

#ifndef _ImportPIE_H_
#include "ImportPIE.h"
#endif /* _ImportPIE_H_ */

#include <math.h>


class GUtil
{
	public:
		static void ReplaceIni(CString& str);
	
		static void SetIniString(CString& ini) {s_INIString = ini;}

		static void SetANEHandle(ANE_PTR handle) {s_ANEHandle = handle;}

		static void ProcessEvents();
	private:
		static CString s_INIString;
		static ANE_PTR s_ANEHandle;

};

class SUTRAProjectInfo
{
public:
	BOOL ShowDialog();
	virtual void CalcAfterDialog();
	SUTRAProjectInfo();

	~SUTRAProjectInfo();

	void PrepareValString();

	void InitFromValFile();

	void Save(CString& saveTo); // save this class state into saveTo string
	void Load(ANE_PTR aneHandle, const char* loadFrom, int* position); // load SUTRALayerInfo from loadTo, starting from position 0, and return the end postion in position

public:

//	enum { kTriMesh, kQuadMesh } EMeshType;
	// model setup flags:
	BOOL defaultSetting;

	enum EOrientation {kAREAL, kCROSS_SECTIONAL} ;
	EOrientation orientation;

	enum EFlowConditions {kSATURATED, kSAT_UNSAT} ;
	EFlowConditions flowConditions;

	enum ETransportConditions {kSOLUTE_VAR, kSOLUTE_CONST, kENERGY} ;
	ETransportConditions transportConditions;

	enum EModelThickness {kUSER_SPEC, kCYLINDRICAL} ;
	EModelThickness modelThickness;

	enum EMeshDesign {kFISHNET_MESH, kIRREGULAR_MESH} ;
	EMeshDesign meshDesign;


	// Pane1:

	long		NTOBS;
	CString		SIMULA;
	CString		TITLE1;
	CString		TITLE2;

	// Pane2:

	double		GNUP;
	double		GNUU;
	int			IREAD;
	int			ISSFLO;
	int			ISSTRA;
	long		ISTORE;
	int			IUNSAT;
	double		UP;

	// Pane3:

	double		DELT;
	double		DTMAX;
	long		ITCYC;
	long		ITMAX;
	long		NPCYC;
	long		NUCYC;
	double		DTMULT;
	double		TMAX;

	// Pane4:

	BOOL		KBUDG;
	BOOL		KELMNT;
	BOOL		KINCID;
	BOOL		KNODAL;
	BOOL		KPLOTP;
	BOOL		KPLOTU;
	BOOL		KVEL;
	long		NPRINT;

	// Pane5:

	long		ITRMAX;
	double		RPMAX;
	double		RUMAX;

	// Pane6:

	double		COMPFL;
	double		CW;
	double		DRWDU;
	double		RHOW0;
	double		SIGMAW;
	double		URHOW0;
	double		VISCO;

	// Pane7:

	CString		ADSMOD;
	double		CHI1;
	double		CHI2;
	double		COMPMA;
	double		CS;
	double		RHOS;
	double		SIGMAS;

	// Pane8:

	double		GRAVX;
	double		GRAVY;
	double		PRODF0;
	double		PRODF1;
	double		PRODS0;
	double		PRODS1;

	// Pane9:

	int			IDIREC;
	long		NCHAPI;
	long		NCHAPL;
	long		NLINPI;
	double		PBASE;
	double		UBASE;

	// Pane10

	long		NOBCYC;
	double		TSTART;

private:
	
	CString valString;
};




#endif /*_SUTRA_PIE_HH_*/

